module SuckerPunch::Persistence
  class Mailbox < ::Celluloid::Mailbox
    def initialize(data_store)
      super()
      self.data_store = data_store
    end

    def <<(message)
      if message.is_a?(::Celluloid::Call) && (arguments = message.arguments.dup).shift == :perform
        record = data_store.create_record(arguments)
        message.extend(SuckerPunch::Persistence::Call)
        message.data_store = data_store
        message.record = record
      end
      super
    end

    private

    attr_accessor :data_store
  end
end
